package com.afx.page;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.springframework.orm.hibernate3.HibernateCallback;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

public class DoPaging extends HibernateDaoSupport{
	StringBuilder hql;
	List<Object> parameters;
	@SuppressWarnings("unchecked")
	public void doPage(final Paging p, final Integer...indexSize){
		parameters = new ArrayList<Object>();
		hql = new StringBuilder("from {class}");
		hql.replace(5, hql.length(), p.getClaszz().getName());
		addCondition(p);
		addOrder(p);
		final String findCounthql = "select COUNT(*) "+ hql;
		super.getHibernateTemplate().execute(new HibernateCallback() {
			public Object doInHibernate(Session session) throws HibernateException, SQLException {
				Integer pageIndex = p.getPageIndex() == null || p.getPageIndex() <= 0? 1 : p.getPageIndex();
				System.out.println(findCounthql);
				Query queryCount = session.createQuery(findCounthql);
				replaceParameter(queryCount, parameters);
				Integer record = ((Long)queryCount.uniqueResult()).intValue();
				Integer pageCount = record%p.getPageSize() == 0?record/p.getPageSize() : record/p.getPageSize()+1;
				p.setPageIndex(pageIndex>pageCount?pageCount:pageIndex);
				p.setRecord(record);
				p.setPageCount(pageCount);
				Query query = session.createQuery(hql.toString());

				try {
					p.setIndexSize((indexSize!=null&&indexSize.length!=0)?(indexSize[0]!=null?indexSize[0]:4):4);
					doPageIndex(p,(indexSize!=null&&indexSize.length!=0)?(indexSize[0]!=null?indexSize[0]:4):4);
				} catch (Exception e) {
					e.printStackTrace();
				}
				replaceParameter(query, parameters);
				p.setList(query.setFirstResult((pageIndex - 1) * p.getPageSize()).setMaxResults(p.getPageSize()).list());
				return null;
			}
		});
	}
	
	private void addCondition(Paging p){
		if (p.getConditions() == null || p.getConditions().size() == 0) {
			return;
		}
		hql.append(" where ");
		for (int i = 0; i < p.getConditions().size(); i++) {
			if (i!=0) {
				hql.append(" and ");
			}
			Condition condition = (Condition) p.getConditions().get(i);
			if (condition.getBet() != null) {
				hql.append(condition.getBet().getFirst());
				hql.append("between ? and ?");
				parameters.add(condition.getBet().getA());
				parameters.add(condition.getBet().getB());
				continue;
			}
			hql.append(condition.getFistField());
			hql.append(condition.getConditionConde());
			hql.append(condition.getConditionConde() .equals(ConditionCode.like)?"%?%":"?");
			parameters.add(condition.getSecondField());
		}
	}
	
	private void addOrder(Paging p){
		if (p.getOrder() == null || p.getOrder().size() == 0) {
			return;
		}
		hql.append(" order by");
		for (int i = 0; i < p.getOrder().size(); i++) {
			Order order = (Order) p.getOrder().get(i);
			hql.append(" "+order.getField());
			hql.append(" "+order.getOrderCode()+",");
		}
		hql.deleteCharAt(hql.length()-1);
		System.out.println(hql);
	}
	
	public void doPageIndex(Paging p,Integer indexSize) {
		Integer start;
			start = indexSize / 2;
		Integer first = p.getPageIndex();
		if (first <= indexSize) {
			p.setStart(1);
			p.setEnd(p.getPageCount()<indexSize?p.getPageCount():indexSize);
		} else {
			if (indexSize <= 2) {
				p.setStart(first);
			} else {
				p.setStart(first - start);
				}
			p.setEnd((first + (indexSize % 2 == 0?(indexSize/2-1!=0?indexSize/2-1:indexSize/2):indexSize/2)) > p.getPageCount()?p.getPageCount():(first + (indexSize % 2 == 0?(indexSize/2-1!=0?indexSize/2-1:indexSize/2):indexSize/2)));
		}
		
		for (int i = p.getStart(); i <= p.getEnd(); i++) {
		}
	}
	
	public void replaceParameter(Query query, List parameters){
		for (int i = 0; i < parameters.size(); i++) {
			query.setParameter(i, parameters.get(i));
		}
	}
}
